(function() {

    function checkStateSelect(items,style,targetIdx){
        for(var idx in items){
            items[idx].removeClass(style);
        }
        items[targetIdx].addClass(style);
    }

    MainPage__on_load = function(){
        logger.d("MainPage__on_load");
    }

    MainPage__on_ready = function(){
        logger.d("MainPage__on_ready");
    }

    MainPage__menu_syn_state = function(){
        if(this.hasClass("navigation_bar_checked")){
            return;
        }
        var ownerPage = this.ownerPage;
        var menuItems = ownerPage.findItemsByClass("navigation_bar");
        var contentArea = ownerPage.findItemById("content-area");
        var pages = contentArea.children;
        var visiblePageIdx;
        for(var idx in menuItems) {
            if ( this == menuItems[idx] ) {
                visiblePageIdx = idx;
                checkStateSelect(menuItems,"navigation_bar_checked",visiblePageIdx);
                break;
            }
        }
        var d_value = visiblePageIdx-contentArea.currentPage;
        switch(d_value){
            case -1:
                contentArea.slidePrev();
                break;
            case 0:
                break;
            case 1:
                contentArea.slideNext();
                break;
            default:
                if(d_value>0){
                    contentArea.setCurrentPage(d_value-1);
                    contentArea.slideNext();
                }else{
                    contentArea.setCurrentPage(visiblePageIdx+1);
                    contentArea.slidePrev();
                }
                break;
        }
    }

    MainPage__navigation_bar_bindingUpdated = function(){
       //以3个字的频道作为最大基线，当viewWidth超过时基线,那选中横条样式img1,img2的padding为3个字频道时的padding
       var maxViewWidth = 174;
       var viewWidth = this.viewWidth;
       var paddingFocusLeft;
       var paddingFocusRight;
       var paddingDefaultLeft;
       var paddingDefaultRight;
       if(viewWidth > maxViewWidth){
           paddingFocusLeft = paddingFocusRight = (viewWidth - maxViewWidth) / 2  + 42; //“42”为3个字的频道时img1的padding值
           paddingDefaultLeft = paddingDefaultRight = (viewWidth - maxViewWidth) / 2 + 39;//“39”为3个字的频道时img2的padding值
           var img1Padding = "63," + paddingFocusLeft + "," + paddingFocusRight + ",0";
           var img2Padding = "63," + paddingDefaultLeft + "," + paddingDefaultRight + ",0";
           this.setAttr("img.1.padding", img1Padding);
           this.setAttr("img.2.padding", img2Padding);
       }
    }


    MainPage__page_change = function(){
        var ownerPage = this.ownerPage;
        var currentPage = this.currentPage;
        logger.d("MainPage__page_change currentPage: "+currentPage);
        var menuArea = ownerPage.findItemById("navigation_area");
        var menuItems = ownerPage.findItemsByClass("navigation_bar");
        var menuSlider = ownerPage.findItemById("navigation_slider");

        if (!menuArea.hasFocus) {
            checkStateSelect(menuItems,"navigation_bar_checked",currentPage);
            menuSlider.makeChildVisible(menuItems[currentPage],0.5,false);
            menuArea.setDynamicFocus(menuItems[currentPage]);
        }

        this.dispatchEvent("page_change", "usr_cmd", "m_change_page");
    }

    MainPage__setting_option_item_checked = function(){
        this.setAttr("img.3.visible","false");
        this.setAttr("img.4.visible","true");
        var settingValue = this.getAttr("text");
        var settingType = this.parent.getData("settingType");
        this.dispatchEvent("click", "save_setting", JSON.stringify({"setting_type":settingType, "setting_value":settingValue}));
    }

    MainPage__setting_option_item_blur = function(){
        this.setAttr("img.3.visible","true");
        this.setAttr("img.4.visible","false");
    }

    MainPage__setting_option_item_focus = function(){
        this.setAttr("img.3.visible","false");
        this.setAttr("img.4.visible","true");
    }

    MainPage__login_out_button_click = function(){
        var loginOutDialog = this.ownerPage.findItemById("login_out_dialog");
        var root = this.ownerPage.findItemById("root");
        var sureItem = loginOutDialog.findItemById("sure");
        if(loginOutDialog != null){
            this.ownerPage.pushStates(loginOutDialog, "setStyle", "display", "block", sureItem, "requestFocus", root, "setDisabled" );
        }
    }

    MainPage__user_login = function(){
        this.dispatchEvent("click", "usr_cmd", "m_open_login_and_register_page");
        this.ownerPage.popStates();
    }

    MainPage__user_login_out_sure = function(){
        var loginButton = this.ownerPage.findItemById("login_button");
        var loginOutDialog = this.ownerPage.findItemById("login_out_dialog");
        if(loginOutDialog != null){
           loginOutDialog.setStyle("display","none");
        }
        this.dispatchEvent("user_login_out", "usr_cmd", "m_user_login_out");
        this.ownerPage.popStates();
        if(loginButton != null){
           loginButton.requestFocus();
        }
    }

    MainPage__user_login_out_cancel = function(){
        var loginOutDialog = this.ownerPage.findItemById("login_out_dialog");
        loginOutDialog.setStyle("display","none");
        this.ownerPage.popStates();
    }

    MainPage__user_template_instanced = function(){
        var playRecordItems = this.findItemsByClass("my_record_item");
        var playRecordArea = this.findItemById("play_record_area");
        var size = playRecordItems.length;
        if(size <= 0){
           playRecordArea.setStyle("display","none")
        } else {
           playRecordArea.setStyle("display","block")
        }
        var channelId = this.getData("channelId");
        this.dispatchEvent("componentInstanced", "m_update_user_page", JSON.stringify({"channelId":channelId}));
    }

    MainPage_report_hotword_poster_click = function(){
            this.dispatchEvent("click", "usr_cmd", "doUiAction");
            this.dispatchEvent("report", "report_hotword_poster_click","report_hotword_poster_click");
        }

    MainPage__setting_template_instanced = function(){
        this.dispatchEvent("init_setting", "usr_cmd", "init_setting");
    }

    MainPage__play_record_incremental_binding_finished = function(){
        this.dispatchEvent("incrementalBindingFinished", "play_record_update_finished", "");
    }

    MainPage_search_incremental_binding_finished = function(){
        this.dispatchEvent("incrementalBindingFinished", "search_finished", "");
    }

    MainPage_static_module_binding_finished = function(){
        var channelId = this.getData("channelId");
        this.dispatchEvent("bindingFinished", "static_module_binding_finished", JSON.stringify({"channelId":channelId}));
    }

    MainPage__play_record_enter_click = function(){
        var fpa = this.getData("fpa");
        this.dispatchEvent("click", "usr_cmd", "m_open_play_history_page");
        this.dispatchEvent("updateFpa", "updateFpa", fpa);
    }

    MainPage__play_record_item_click = function(){
        var fpa = this.getData("fpa");
        this.dispatchEvent("click", "usr_cmd", "doUiAction");
        this.dispatchEvent("updateFpa", "updateFpa", fpa);
    }
    MainPage__channel_live_finish = function(){
        var str = this.getAttr("text");
        if(str != null && str.length > 0) {
            this.setAttr("text", "LIVE");
            this.parent.children[0].setStyle("display", "none");
        } else{
            this.parent.children[0].setStyle("display", "block");
        }
    }
    MainPage__channel_vip_finish = function(){
        var corner = this.getAttr("corner");
        if(corner != null && corner.length > 0) {
            this.setStyle("display", "block");
            this.parent.children[0].setStyle("max-width", "372");
        } else{
            this.setStyle("display", "none");
        }
    }
})("main_page");