(function () {
	function togglePlayerUi(target, show) {
		logger.d("togglePlayerUi", "togglePlayerUi start:" + target.id + ":" + show);
		if (!target) {
			return;
		}

		if (typeof(show) == "undefined") {
			show = !target.hasClass("player-ui-shown");
		}
		if (show) {
			target.addClass("player-ui-shown");
			if("player-menu" == target.id){
                var items = target.findItemsByClass("menu_item");
                if(items != null && items.length > 0){
                    items[0].requestFocus();
                    logger.d("menu_item requestFocus.");
                }
            }else if("player-exit" == target.id){
                 var exit = target.findItemById("menu_btn_exit");
                 if(exit != null){
                    exit.requestFocus();
                 }
            } else {
                if("quit-page" == target.id){
                    var items = target.findItemsByClass("group_item");
                    if(items != null && items.length > 0){
                        items[0].requestFocus();
                        logger.d("group_item requestFocus.");
                    }
                 }else{
                    target.requestFocus();
                 }
            }
		} else {
			target.removeClass("player-ui-shown");
		}
	}

	function toggleMultiPlayerUi(ownerPage, targets, show) {
		for (var idx in targets) {
			var target = ownerPage.findItemById(targets[idx]);
			togglePlayerUi(target, show);
		}
	}

	var uiTargets = {
		"Menu": ["player-menu"],
		"PlayInfo": ["player-info"],
		"videoLoading": ["player-loading"],
		"toast": ["player-toast"],
		"extToast": ["player-ext-toast"],
		"ControlBar": ["player-title", "control-bar"],
		"TitleFrame": ["player-title"],
		"conPlayView":["conPlay-view"],
		"exit_page":["player-exit"]
	};

	MediaPlayer_toggleUI = function (id, show) {
		var targets = uiTargets[id];
		if (!targets) {
			return;
		}
		toggleMultiPlayerUi(this.ownerPage, targets, show);
	};
	hotword_poster_click = function(){
	   var data = this.getAttr("data");
       logger.d("hotword_poster_click:  data" + data);
       if(data != "null"){
           this.dispatchEvent("exit_page_action", "exit_page_action", "refreshcurpageinfo");
           this.dispatchEvent("exit_page_action", "exit_page_action", "quit_to_exit");
           this.dispatchEvent("click", "usr_cmd", "doUiAction");
       }
    }

})("MediaPlayer");