(function () {
	function playbill_doAlignList(list) {
		var alignMode = list.getAttr("align-mode");
		if (!alignMode) {
			return;
		}
		var rootSlider = list.findParentByType("slider");
		var fixAlignMode;
        if("commonCategory" ==list.ownerPage._categoryType){
		    fixAlignMode = alignMode+"1";
        }else{
            fixAlignMode = alignMode;
        }
		var  alignParam = rootSlider.getAttr("align-mode-"+fixAlignMode);
		if (!alignParam) {
			logger.e("playbill_doAlignList", " invalid alignParam mode=", fixAlignMode, " - ", alignParam);
			return;
		}
        if (rootSlider.__alignMode == fixAlignMode ) {
            return;
        }
        rootSlider.__alignMode = fixAlignMode;
        if("A" == alignMode){
            var commonChannelLayer = rootSlider.findItemById("common-channel-layer");
            var channelList = rootSlider.findItemById("channel-list");
            if("commonCategory" == list.ownerPage._categoryType){
                channelList.addClass("hidden-item");
                commonChannelLayer.removeClass("hidden-item");
            }else{
                commonChannelLayer.addClass("hidden-item");
                channelList.removeClass("hidden-item");
            }
        }
		var component = list.findParentByType("component");
		alignParam = JSON.parse(alignParam);
		var alignTarget = component.findItemById(alignParam.alignTarget);
		logger.e("playbill_doAlignList", "alignParam.width"+alignParam.width);
		rootSlider.setAttr("width", alignParam.width);
		rootSlider.makeChildVisible(alignTarget, alignParam.alignment);
		if (alignParam.show) {
			for(var idx in alignParam.show) {
				var showTarget = alignParam.show[idx];
				showTarget = component.findItemById(showTarget);
				showTarget.removeClass("hidden-item");
			}
		}
		if (alignParam.hide) {
			for(var idx in alignParam.hide) {
				var showTarget = alignParam.hide[idx];
				showTarget = component.findItemById(showTarget);
				showTarget.addClass("hidden-item");
			}
		}
	}

	function playbill_onItemFocused(item) {
	    var listSlider = item.findParentByClass("playbill-list");
		playbill_doAlignList(listSlider);

		var layer = item.findParentByClass("effect-layer");
		var effectType = layer.getAttr("effect-type");
		var rootSlider = item.findParentByClass("playbill-root-slider");
		if (rootSlider.__effectType == effectType ) {
            return;
        }
		var effectLayers = rootSlider.findItemsByClass("effect-layer");
        for(var idx in effectLayers) {
            var effectLayer = effectLayers[idx];
            effectLayer.addClass("darken-layer");
        }
        layer.removeClass("darken-layer");
        rootSlider.__effectType=effectType;
	};

    MediaPlayer_playbill_doAlignList = function(){
        this.ownerPage._categoryType = arguments[0];
        playbill_doAlignList(this);
    }

    MediaPlayer_playbill_categoryItemFocused = function(){
        this.ownerPage._categoryType = this.getAttr("categoryType")
        logger.d("MediaPlayer_playbill_categoryItemFocused", this.ownerPage._categoryType);
        playbill_onItemFocused(this);
        var rootSlider = this.findParentByClass("playbill-root-slider");
        hideChannelManage(this, rootSlider);
        this.dispatchEvent("click", "playbill_cmd", "SwitchCategory");
    }

    MediaPlayer_playbill_channelItemFocused = function(){
        this.dispatchEvent("getDelay", "playbill_cmd", "delayFetchAliveChannel");
        var rootSlider = this.findParentByClass("playbill-root-slider");
        showRightIndicator(rootSlider);
        hideChannelManage(this, rootSlider);
        playbill_onItemFocused(this);
        this.dispatchEvent("click", "playbill_cmd", "SwitchChannel");
    }

    MediaPlayer_playbill_dateItemFocused = function(){
        playbill_onItemFocused(this);
        this.dispatchEvent("click", "playbill_cmd", "SwitchDate");
    }

    MediaPlayer_playbill_programItemFocused = function(){
        playbill_onItemFocused(this);
    }

    MediaPlayer_playbill_channelManageFocus = function(){
        channelManage("focus",this);
    }

    MediaPlayer_playbill_channelManageBlur = function(){
        channelManage("blur",this)
    }

    MediaPlayer_navigation_bar_bindingUpdated = function(){
       //以3个字的频道作为最大基线，当viewWidth超过时基线,那选中横条样式img1,img2的padding为3个字频道时的padding
       var maxViewWidth = 174;
       var viewWidth = this.viewWidth;
       var paddingFocusLeft;
       var paddingFocusRight;
       var paddingDefaultLeft;
       var paddingDefaultRight;
       if(viewWidth > maxViewWidth){
           paddingFocusLeft = paddingFocusRight = (viewWidth - maxViewWidth) / 2  + 42; //“42”为3个字的频道时img1的padding值
           paddingDefaultLeft = paddingDefaultRight = (viewWidth - maxViewWidth) / 2 + 39;//“39”为3个字的频道时img2的padding值
           var img1Padding = "63," + paddingFocusLeft + "," + paddingFocusRight + ",0";
           var img2Padding = "63," + paddingDefaultLeft + "," + paddingDefaultRight + ",0";
           this.setAttr("img.1.padding", img1Padding);
           this.setAttr("img.2.padding", img2Padding);
       }
    }

    function channelManage(type, item) {
        var rootSlider = item.findParentByClass("playbill-root-slider");
        var parentSlider = rootSlider.findParentByType("slider");
        var allChannelLayer = parentSlider.findItemById("all-channel-layer");
        var rightIndicator = parentSlider.findItemById("right-indicator");
        var date = rootSlider.findItemById("date_layer");
        var playbill = rootSlider.findItemById("playbill_layer");
        if("focus" == type) {
           playbill.addClass("hidden-item");
           date.addClass("hidden-item");
           allChannelLayer.removeClass("hidden-item");
           rightIndicator.addClass("hidden-item");
           rootSlider.setAttr("width","639");
           rootSlider.__alignMode = "A1";
           item.dispatchEvent("operate", "playbill_cmd", "SwitchAllCommonChannelShow");
        }
        playbill_onItemFocused(item);
    }

    function hideChannelManage(item, rootSlider) {
        var parentSlider = rootSlider.findParentByType("slider");
        var allChannelLayer = parentSlider.findItemById("all-channel-layer");
        var date = rootSlider.findItemById("date_layer");
        var playbill = rootSlider.findItemById("playbill_layer");
        allChannelLayer.addClass("hidden-item");
        playbill.removeClass("hidden-item");
        date.removeClass("hidden-item");
        item.dispatchEvent("operate", "playbill_cmd", "SwitchAllCommonChannelHide");
    }

    function showRightIndicator(rootSlider) {
        var date = rootSlider.findItemById("date_layer");
        var parentSlider = rootSlider.findParentByType("slider");
        if (date.hasClass("hidden-item")) {
             var rightIndicator = parentSlider.findItemById("right-indicator");
             rightIndicator.removeClass("hidden-item");
        }
    }

})("MediaPlayerDefaultUI");